function result=BreakDate(e1,p1,listrestr,listunr,heter,tv); 
%This file does tests for structural breaks

%INPUT is:
%The constant is included automatically (so it cannot be included in p1)
%e1 is the independent variable
%p1 is the dependent variable
%listrestr is the vector containing the list of restricted parameters --
% those for which you want to test whether there is a break
% and listunr is the vector containing the list of the parameters that are known to be constant 
% the constant is always ordered first
%e.g. if y=a+bx+cz and want to test a break in the constant then listrestr=[1] and listunr=[2 3]
%e.g. if y=a+bx+cz and want to test a break in a,b then listrestr=[1 2] and listunr=[3]
%e.g. if y=a+bx+cz and want to test a break in c then listrestr=[3] and listunr=[1 2]
%e.g. if y=a+bx+cz and want to test a break in a,b,c then listrestr=[1 2 3] and listunr=0

%heter=1 if robust to cond heteroskedasticity; heter=0 if cond homoskedasticity is imposed
%tv is the vector of time dates 

[T,kk]=size(p1);   
p1plusc=[ones(T,1),p1]; p1restr=p1plusc(:,listrestr); 
if listunr==0; p1unr=0; else p1unr=p1plusc(:,listunr); end;
[T,kk]=size(p1restr); 
t2v=round(T*0.15):1:round(T*0.85); 
Andrews=zeros(length(t2v),1); AP=0; Nyb=0; AP0=0; maxAndrews=0; 
for t2=t2v;   
   chow=chowgmm(e1,p1restr,p1unr,p1plusc,t2,heter);
   Andrews(t2-round(T*0.15)+1,1)=chow;
   AP=AP+(exp(0.5*chow));
   Nyb=Nyb+chow*(t2/T)*(1-t2/T);
   AP0=AP0+(exp(0.5*chow)); 
   if chow>=max(Andrews); timebreak=t2;  end;   
end;

result=tv(timebreak,:); 

