%This file updates tables in Chen, Rogoff and Rossi (2007)
%FORECAST COMBINATIONS AND MULTIVARIATE GC TESTS

%to plot forecast figure, set wanttoplot=1;

clear; 
Rwindow=50; 
wanttoplot=1; 
lagdep=1; %(set lagdep=0 to get no lagged cp in OOS forec regression and lagdep=1 to get lagged cp included in OOS forec regression)
const=1;
bic=1; %=1 if want to use bic lags -- otherwise set below
p=4; %VAR lags
b=0.99; %discount factor
alpha=0.05; %quantile for bootstrap distribution of variance ratio
B=2000; %n. of bootstrap replications
do_boot=0; %0 if do not want to run the bootstrap
do_kilian=0; %0 if do not want to run kilian's bootstrap
lagscorr=[-5:1:5]; %leads and lags for correlations
spuriouscheck=0;  %if =1 then the program generates iid fundamentals
hac=1; 

NF=6; NC=3; 
 

fVMatrix=[[2:(NF+1):NC*(NF+1)]',[3:(NF+1):NC*(NF+1)]',[4:(NF+1):NC*(NF+1)]',[5:(NF+1):NC*(NF+1)]',[6:(NF+1):NC*(NF+1)]',[7:(NF+1):NC*(NF+1)]']; [ll,nn]=size(fVMatrix);
%Fundamentals (nfund):  1=DISR,  2=DILR,   3=DINF,   4=Y,   5=IMP,   6=CP 

TableGC=[]; TableGCTVP=[]; TableGCOpt=[]; TableMSE=[]; TableCMcCRol=[]; TableCMcCRec=[];
TableGC1=[]; TableGCTVP1=[]; TableGCOpt1=[]; TableMSE1=[]; TableCMcCRol1=[]; TableCMcCRec1=[];
Table_VarRatio=[]; Table_VarRatioK=[]; Table_VarRatioMC=[]; TableGCNPV=[]; TableFundTVP=[]; TableFundOpt=[];
Table_LH=[]; Table_LH1=[];
TableFundTVP_date=[]; TableGC_date=[]; TableGCTVP_date=[]; TableGCOpt_date=[]; 
TableGC1_date=[]; TableGCTVP1_date=[]; TableGCOpt1_date=[];

for nfund=nn; 1:nn; 
    fV=fVMatrix(:,nfund); 
    a=1; [1,-1]; 
    s_AU=1; s_NZ=8; s_CA=15; s_SA=22;
    sV=[s_AU;s_NZ;s_CA;s_SA];
    VarRatio=[]; table_quantiles=[]; table_correl=lagscorr; table_var=[]; table_bic=[];
    table_var_Kilian=[]; table_quantiles_Kilian=[]; table_instability=[]; 
    table_instability1=[]; table_instability2=[]; table_instability3=[]; LHv=[]; LHv1=[];
    table_instability_date=[]; table_instability1_date=[]; 
    table_instability2_date=[]; table_instability3_date=[];
    table_instability2F=[]; table_instability3F=[];
        
    for ncountry=1; 
        
    s_all=[]; s_level_all=[]; 
    for ncountryA=1:NC;  
        fnA=fV(ncountryA,:); snA=sV(ncountryA,:);
        %load data
        AggData2=xlsread('NERall_us_2013new1'); NERall=AggData2; sA=NERall(:,snA);
        %Differencing the data
        s_levelA=sA;  
        sA=diff(sA,1);  
        s_all=[s_all,sA]; s_level_all=[s_level_all,s_levelA]; 
    end; 
    
        fn=fV(ncountry,:); sn=sV(ncountry,:);
        %load data
        AggData2=xlsread('NERall_us_2013new1'); NERall=AggData2; s=NERall(:,sn);
        %y=commodity price (i.e. fundamental); s=exchange rate
        
        %*****************************************************************
        %Load forward AIG data
        aig=xlsread('DJdata-quarterlyFromYC.xls');  
        fwd_level=log(aig(:,2));  y_level=log(aig(:,1)); 
        %******************************************************************
        
        %Differencing the data
        s_level=s; 
        time=calendar(1972,1,168,'q'); tds=calendar_plot(1972,1,168,'q');

        %clean NaN's
        X=[y_level,s_level,time,tds,s_level_all,fwd_level]; X=cleanNaN(X); 
     if isempty(X)~=1; 
        y_level=X(2:end,1); 
        s_level=X(2:end,2); 
        time=X(2:end,3:4); 
        tds=X(2:end,5); 
        s_level_all=X(2:end,6:8); 
        fwd_level=X(2:end,9);   
        if spuriouscheck==1; y=randn(length(y),1).*sqrt(cov(y)); end;  
        y=diff(X(:,1),1);
        s=diff(X(:,2),1); 
        s_all=diff(X(:,6:8),1);

        %SECOND PLOT!!
        if wanttoplot==1;   
         plotforec=plotforectestshacfwd(y(2:end),[s_all(1:end-1,:)],[1,2],0,tds(2:end),fwd_level(1:end-1,:)-y_level(1:end-1,:),Rwindow);    
        end;
                
     else; 
        disp('cannot plot');
     end;  
        
    end; 

end; 

