%This file updates tables in Chen, Rogoff and Rossi (2007)

clear; warning off all; 

%CHANGE THE LINE BELOW TO OBTAIN EITHER RW OR AR BENCHMARK FOR OOS:
lagdep=0; %(set lagdep=0 to get no lagged cp in OOS regression and lagdep=1 to get lagged cp included in OOS regression)
%CHANGE THE LINE BELOW TO OBTAIN EITHER RW OR RW WITH DRIFT FOR OOS:
rwwd=0; %(set lagdep=0 and rwwd=1 to have rw with drift as benchmark, 
        % and set lagdep=0 and rwwd=0 to have rw without drift as benchmark) 
const=1;
fCWmatrix=zeros(20,5); 

for numOBS=135:167; close all; 

    Rwindowvector=[48;41;70;37;28]; 
    bic=1; %=1 if want to use bic lags -- otherwise set below
    p=4; %VAR lags
    b=0.99; %discount factor
    alpha=0.05; %quantile for bootstrap distribution of variance ratio
    B=2000; %n. of bootstrap replications
    lagscorr=[-5:1:5]; %leads and lags for correlations
    spuriouscheck=0;  %if =1 then the program generates iid fundamentals
    hac=1; 

    NF=6; NC=5; %NF=n. of fundamentals for each country and NC=n. countries
    fVMatrix=[[2:(NF+1):NC*(NF+1)]',[3:(NF+1):NC*(NF+1)]',[4:(NF+1):NC*(NF+1)]',[5:(NF+1):NC*(NF+1)]',[6:(NF+1):NC*(NF+1)]',[7:(NF+1):NC*(NF+1)]']; [ll,nn]=size(fVMatrix);
    %Fundamentals (nfund):  1=DISR,  2=DILR,   3=DINF,   4=Y,   5=IMP,   6=CP 

    TableGC=[]; TableGCTVP=[]; TableGCOpt=[]; TableMSE=[]; TableCMcCRol=[]; TableCMcCRec=[];
    TableGC1=[]; TableGCTVP1=[]; TableGCOpt1=[]; TableMSE1=[]; TableCMcCRol1=[]; TableCMcCRec1=[];
    Table_VarRatio=[]; Table_VarRatioK=[]; Table_VarRatioMC=[]; TableGCNPV=[]; TableFundTVP=[]; TableFundOpt=[];
    Table_LH=[]; Table_LH1=[];
    TableFundTVP_date=[]; TableGC_date=[]; TableGCTVP_date=[]; TableGCOpt_date=[]; 
    TableGC1_date=[]; TableGCTVP1_date=[]; TableGCOpt1_date=[];
    table_R2cIS=[]; table_R2c1IS=[]; table_R2cOOS=[]; table_R2c1OOS=[];

    for nfund=nn; 1:nn; disp(['Fundam = ',num2str(nfund)]);
        fV=fVMatrix(:,nfund); 
        a=1; [1,-1]; 
        s_AU=1; s_NZ=8; s_CA=15; s_CH=22; s_SA=29;
        sV=[s_AU;s_NZ;s_CA;s_CH;s_SA];
        VarRatio=[]; table_quantiles=[]; table_correl=lagscorr; table_var=[]; table_bic=[];
        table_var_Kilian=[]; table_quantiles_Kilian=[]; table_instability=[]; 
        table_instability1=[]; table_instability2=[]; table_instability3=[]; LHv=[]; LHv1=[];
        table_instability_date=[]; table_instability1_date=[]; 
        table_instability2_date=[]; table_instability3_date=[];
        table_instability2F=[]; table_instability3F=[]; 
        R2v2=[]; R2v3=[];  

        for ncountry=1:5; close all; 
            Rwindow=Rwindowvector(ncountry,1);
            fn=fV(ncountry,:); sn=sV(ncountry,:);
            %load data
            NERall2=xlsread('NERall_us_2013b');
            NERall=NERall2(1:numOBS,:);  
            y=NERall(:,fn); s=NERall(:,sn);
            %y=commodity price (i.e. fundamental); s=exchange rate

            %Differencing the data
            y_level=y; s_level=s; y=diff(y,1); 
            s=diff(s,1); Tsize=size(s,1); 
            time=calendar(1972,2,Tsize,'q');  
            tds=calendar_plot(1972,2,Tsize,'q');

            %clean NaN's
            X=[y,s,time,tds]; X=cleanNaN(X); 
         if isempty(X)~=1; y=X(:,1); s=X(:,2); time=X(:,3:4); tds=X(:,5);   
            if spuriouscheck==1; y=randn(length(y),1).*sqrt(cov(y)); end; 
            Xl=[y(1:end,:),s(1:end,:)]; Xl=cleanNaN(Xl); 
            y_level=Xl(:,1); s_level=Xl(:,2); 
            s_diff=diff(s_level,1); y_diff=diff(y_level,1);  
            y_level=y_level(2:end,:); s_level=s_level(2:end,:);

            %Lag length
            if bic==1; BIClag=ICvar(y,6,1,'BIC'); table_bic=[table_bic;BIClag]; p=BIClag; 
            end;
            Xi_b=var_phi1b(y,p,const,b); 
            eps=var_res(y,p,const); 
            DeltaXf=(a*(inv(Xi_b))*eps')';
            VarRatio=[VarRatio;cov(DeltaXf)/cov(s(p+1:end))];
            VarRatiomiss=cov(DeltaXf)/cov(s(p+1:end)).*nan;

            %VAR ESTIMATES
            table_var=[table_var;[var_coeff(y,p,const)'; sqrt(diag(var_coeffvar(y,p,const)))']];

            %ENDOGENEITY TESTS
            cor=[]; 
            cp=NERall(:,fn); exchrate=NERall(:,sn); 
            %y=commodity price (i.e. fundamental); s=exchange rate
            cp_glob=xlsread('CP122913'); 
            cp_glob=cp_glob(1:numOBS,1); 

            %Differencing the data
            cp_level=cp; exchrate_level=exchrate; cp_glob_level=cp_glob;
            cp=diff(cp,1); exchrate=diff(exchrate,1); cp_glob=diff(cp_glob,1); 
            Tsize1=size(cp_glob,1);
            timeNEW=calendar(1972,1,Tsize1,'q'); tdsNEW=calendar_plot(1972,1,Tsize1,'q');
            XNEW=[cp,exchrate,cp_glob,timeNEW,tdsNEW]; XNEW=cleanNaN(XNEW); 
            cp=XNEW(:,1); exchrate=XNEW(:,2); cp_glob=XNEW(:,3); timeNEW=XNEW(:,4:5); tdsNEW=XNEW(:,6); 
            uno=ones(size(cp,1),1);
            heter=1; hac=1; 
            wanttrend=0;
            if wanttrend==1;  trend=cumsum(uno); 
            b_ols = gmmbetahac(exchrate,[uno,cp,trend],[uno,cp,trend],heter,hac); 
            v_ols = gmmvarhac(exchrate,[uno,cp,trend],[uno,cp,trend],heter,hac);
            b_gmm = gmmbetahac(exchrate,[uno,cp,trend],[uno,cp_glob,trend],heter,hac); 
            v_gmm = gmmvarhac(exchrate,[uno,cp,trend],[uno,cp_glob,trend],heter,hac);
            T_cp_glob=size(cp_glob,1)-3; 
            elseif wanttrend==0; 
            b_ols = gmmbetahac(exchrate,[uno,cp],[uno,cp],heter,hac); 
            v_ols = gmmvarhac(exchrate,[uno,cp],[uno,cp],heter,hac);  
            b_gmm = gmmbetahac(exchrate,[uno,cp],[uno,cp_glob],heter,hac); 
            v_gmm = gmmvarhac(exchrate,[uno,cp],[uno,cp_glob],heter,hac);
            T_cp_glob=size(cp_glob,1)-2; 
            end;

            %Instability tests
            %(a) on the AR coefficients:
            ylagged=[]; for j=1:p;
                ylagged=[ylagged,y(p+1-j:end-j,:)];
            end;
            result=testshac(y(p+1:end,:),ylagged,[1:1:p+1],0,Rwindow);  
            table_instability=[table_instability;result];
            table_instability_date=[table_instability_date;BreakDate(y(p+1:end,:),ylagged,[1:1:p+1],0,1,time)'];

            %(b) on the parameter relating exchange rates and fundamentals
            result1=testshac(s(p+1+1:end),DeltaXf(1:end-1),[1,2],0,Rwindow); 
            table_instability1=[table_instability1;result1];
            table_instability1_date=[table_instability1_date;BreakDate(s(p+1+1:end),DeltaXf(1:end-1),[1,2],0,1,time)];

            %(c) GC test: fundamentals GC exchange rates?
            result2=testshac(s(2:end),[y(1:end-1),s(1:end-1)],[1,2],3,Rwindow);  
            if lagdep==0; 
                if rwwd==0;
                result2F=testshac(s(2:end),[y(1:end-1)],[1,2],0,Rwindow);    
                R2=testshacR2(s(2:end),[y(1:end-1)],[1,2],0);  
                elseif rwwd==1;
                result2F=testshacRWWD(s(2:end),[y(1:end-1)],[1,2],0,Rwindow);  
                R2=testshacR2(s(2:end),[y(1:end-1)],[1,2],0);  
                end;
            elseif lagdep==1;
            result2F=testshacAR(s(2:end),[y(1:end-1),s(1:end-1)],2,[1,3],Rwindow);  
            R2=testshacR2(s(2:end),[y(1:end-1),s(1:end-1)],2,[1,3]);  
            end; 
            table_instability2=[table_instability2;result2];
            table_instability2F=[table_instability2F;result2F];
            table_instability2_date=[table_instability2_date;BreakDate(s(2:end),[y(1:end-1),s(1:end-1)],[1,2],3,1,time)];
            missdate=BreakDate(s(2:end),y(1:end-1),[1,2],0,1,time).*nan;  
            R2v2=[R2v2; R2]; 

            %(d) GC test: exchange rates GC fundamentals
            result3=testshac(y(2:end),[s(1:end-1),y(1:end-1)],[1,2],3,Rwindow);  
            if lagdep==0; 
                if rwwd==0;
                result3F=testshac(y(2:end),[s(1:end-1)],[1,2],0,Rwindow);    
                R2=testshacR2(y(2:end),[s(1:end-1)],[1,2],0);   
                elseif rwwd==1;
                result3F=testshacRWWD(y(2:end),[s(1:end-1)],[1,2],0,Rwindow);    
                R2=testshacR2(y(2:end),[s(1:end-1)],[1,2],0);   
                end;
            elseif lagdep==1;            
                result3F=testshacAR(y(2:end),[s(1:end-1),y(1:end-1)],2,[1,3],Rwindow);  
                R2=testshacR2(y(2:end),[s(1:end-1),y(1:end-1)],2,[1,3]);  
            end;
            load froll; windowSize=20; if ncountry>=4; windowSize=15; end; 
            y1r=filter(ones(1,windowSize)/windowSize,1,froll(1:end-2)); y11r=y1r(windowSize:end,:); figure; plot(tds(end-size(y11r,1)+1:end,:),y11r);  
            load fCW; fCWmatrix(numOBS-129+1,ncountry)=mean(fCW); save fCWmatrix fCWmatrix -ascii;             
            
            
            table_instability3=[table_instability3;result3];
            table_instability3F=[table_instability3F;result3F];
            table_instability3_date=[table_instability3_date;BreakDate(y(2:end),[s(1:end-1),y(1:end-1)],[1,2],3,1,time)];
            R2v3=[R2v3; R2]; 

            %Long horizon regressions
            %fund GC exchange rates
            hvec=[1,4,8]; [1,5,10,15]; LH=[];  
            for h=hvec; 
             LH=[LH;[LongHgen(s_diff(2:end),y_level(2:end),s_diff(1:end-1),0.95,4,h)]];
            end; if ncountry==1; LH=[hvec',LH]; end;  
            LHv=[LHv,LH]; 
            %exchange rates GC f
            hvec=[1,4,8]; [1,5,10,15]; LH1=[]; 
            for h=hvec; 
             LH1=[LH1;[LongHgen(y_diff(2:end),s_level(2:end),y_diff(1:end-1),0.95,4,h)]];
            end; if ncountry==1; LH1=[hvec',LH1]; end;  
            LHv1=[LHv1,LH1]; 

         else; 
            table_correl=[table_correl;cor.*nan];
            table_instability=[table_instability;result.*nan];
            table_instability_date=[table_instability_date;missdate'];
            table_instability1=[table_instability1;result1.*nan];
            table_instability1_date=[table_instability1_date;missdate];
            table_instability2=[table_instability2;result2.*nan];
            table_instability2_date=[table_instability2_date;missdate];
            table_instability3=[table_instability3;result3.*nan];
            table_instability2F=[table_instability2F;result2.*nan];
            table_instability3F=[table_instability3F;result3.*nan];
            table_instability3_date=[table_instability3_date;missdate];
            LHv=[LHv,LH.*nan]; 
            LHv1=[LHv1,LH1.*nan]; 
            VarRatio=[VarRatio;VarRatiomiss];
         end;  

        end;  

    %Save p-values only
    jpval=[2:2:2*NC];
    tn=2; %2=picks andrews in instab tests, 3 picks Exp-W
    TableFundTVP=[TableFundTVP;table_instability(jpval,tn)']; 
    TableFundTVP_date=[TableFundTVP_date;table_instability_date'];
    TableFundOpt=[TableFundOpt;table_instability(jpval,5)']; 
    TableGC     =[TableGC;     table_instability3(jpval,1)']; 
    TableGCTVP  =[TableGCTVP;  table_instability3(jpval,tn)']; 
    TableGCTVP_date  =[TableGCTVP_date;  table_instability3_date']; 
    TableGCOpt  =[TableGCOpt;  table_instability3(jpval,5)']; 
    TableMSE    =[TableMSE;    table_instability3F([1:2:end-1],11)']; 
    TableCMcCRol=[TableCMcCRol;table_instability3F(jpval,end)']; 
    TableCMcCRec=[TableCMcCRec;table_instability3F(jpval,end-1)']; 
    TableGC1    =[TableGC1;    table_instability2(jpval,1)']; 
    TableGCTVP1 =[TableGCTVP1; table_instability2(jpval,tn)']; 
    TableGCTVP1_date =[TableGCTVP1_date; table_instability2_date']; 
    TableGCOpt1 =[TableGCOpt1; table_instability2(jpval,5)']; 
    TableMSE1   =[TableMSE1;   table_instability2F([1:2:end-1],11)']; 
    TableCMcCRol1=[TableCMcCRol1;  table_instability2F(jpval,end)']; 
    TableCMcCRec1=[TableCMcCRec1;  table_instability2F(jpval,end-1)']; 
    TableGCNPV =[TableGCNPV;   [table_instability1(jpval,[1,2,5,end])';table_instability1([1:2:end-1],[end])']]; 
    Table_VarRatio=[Table_VarRatio; [VarRatio']];
    Table_VarRatioMC=[Table_VarRatioMC; [VarRatio';table_quantiles']];
    Table_VarRatioK=[Table_VarRatioK; [VarRatio'; table_quantiles_Kilian']];
    Table_LH=[Table_LH;[nfund*ones(rows(LHv),1),LHv]]; 
    Table_LH1=[Table_LH1;[nfund*ones(rows(LHv1),1),LHv1]];
    table_R2cIS=[table_R2cIS;R2v3(:,1)']; table_R2c1OOS=[table_R2c1OOS;R2v2(:,2)'];
    table_R2cIS=[table_R2cIS;R2v3(:,1)']; table_R2c1OOS=[table_R2c1OOS;R2v2(:,2)'];

    end;  

end;

    figure; 
    T=size(fCWmatrix,1); t=tds(end-T+1:end,:); 
    t1=t(7:end,:); fCWmatrix1=fCWmatrix(7:end,:); 
    plot(t1,fCWmatrix1(:,1),'b',t1,fCWmatrix1(:,2),'bo--',t1,fCWmatrix1(:,3),'b+--', t1,fCWmatrix1(:,4),'bx--'); 
    hold on;
    plot(t1,ones(size(t1,1),1)*ooscv(1,0.10,2,2),'k--');    
    legend('AUS','NZ','CAN', 'CHI','10% c.v.');   
    ylabel('Clark and McCracken''s Test Statistic'); 
    xlabel('Time')


