%This file updates tables in Chen, Rogoff and Rossi (2007)

clear; delete Table6.out; 
lagdep=1; %(set lagdep=0 to get no lagged cp in OOS regression and lagdep=1 to get lagged cp included in OOS regression)
rwwd=0; %(set lagdep=0 and rwwd=1 to have rw with drift as benchmark, 
        % and set lagdep=0 and rwwd=0 to have rw without drift as benchmark) 
const=1;
tableb=0; %=1 to print tests on b1 only otherwise =0 to print joint tests on b0 and b1
%(that is tableb=0 to print table A and tableb=1 to print table B)

startSAMPLE=2; numOBS=167; 
Rwindow=50;  

bic=1; %=1 if want to use bic lags -- otherwise set below
p=4; %VAR lags
b=0.99; %discount factor
alpha=0.05; %quantile for bootstrap distribution of variance ratio
B=2000; %n. of bootstrap replications
do_boot=0; %0 if do not want to run the bootstrap
do_kilian=0; %0 if do not want to run kilian's bootstrap
lagscorr=[-5:1:5]; %leads and lags for correlations
spuriouscheck=0;  %if =1 then the program generates iid fundamentals
hac=1; 

NF=6; NC=5; %NF=n. of fundamentals for each country and NC=n. countries
fVMatrix=[[2:(NF+1):NC*(NF+1)]',[3:(NF+1):NC*(NF+1)]',[4:(NF+1):NC*(NF+1)]',[5:(NF+1):NC*(NF+1)]',[6:(NF+1):NC*(NF+1)]',[7:(NF+1):NC*(NF+1)]']; [ll,nn]=size(fVMatrix);
%Fundamentals (nfund):  1=DISR,  2=DILR,   3=DINF,   4=Y,   5=IMP,   6=CP 

TableGC=[]; TableGCTVP=[]; TableGCOpt=[]; TableMSE=[]; TableCMcCRol=[]; TableCMcCRec=[];
TableGC1=[]; TableGCTVP1=[]; TableGCOpt1=[]; TableMSE1=[]; TableCMcCRol1=[]; TableCMcCRec1=[];
Table_VarRatio=[]; Table_VarRatioK=[]; Table_VarRatioMC=[]; TableGCNPV=[]; TableFundTVP=[]; TableFundOpt=[];
Table_LH=[]; Table_LH1=[];
TableFundTVP_date=[]; TableGC_date=[]; TableGCTVP_date=[]; TableGCOpt_date=[]; 
TableGC1_date=[]; TableGCTVP1_date=[]; TableGCOpt1_date=[];

for nfund=nn; 1:nn; disp(['Fundam = ',num2str(nfund)]);
    fV=fVMatrix(:,nfund); 
    a=1; [1,-1]; 
    s_AU=1; s_NZ=8; s_CA=15; s_CH=22; s_SA=29;
    sV=[s_AU;s_NZ;s_CA;s_CH;s_SA];
    VarRatio=[]; table_quantiles=[]; table_correl=lagscorr; table_var=[]; table_bic=[];
    table_var_Kilian=[]; table_quantiles_Kilian=[]; table_instability=[]; 
    table_instability1=[]; table_instability2=[]; table_instability3=[]; LHv=[]; LHv1=[];
    table_instability_date=[]; table_instability1_date=[]; 
    table_instability2_date=[]; table_instability3_date=[];
    table_instability2F=[]; table_instability3F=[];
    for ncountry=1:NC;  
        fn=fV(ncountry,:); sn=sV(ncountry,:);        
        NERall2=xlsread('NERall_us_2013');  
        NERall=NERall2(startSAMPLE-1:numOBS,:);  
        s=NERall(:,sn);
        cp_glob=xlsread('CP2013other'); 
        y=cp_glob(startSAMPLE-1:numOBS,1);  
        
        
        %Differencing the data
        y_level=y; s_level=s; y=diff(y,1); 
        s=diff(s,1); 
        time=calendar(1972,1,numOBS,'q'); tds=calendar_plot(1972,1,numOBS,'q');
        time=time(startSAMPLE:end,:); tds=tds(startSAMPLE:end,:); 
       
        %clean NaN's
        X=[y,s,time,tds]; X=cleanNaN(X); 
     if isempty(X)~=1; y=X(:,1); s=X(:,2); time=X(:,3:4); tds=X(:,5);   
        if spuriouscheck==1; y=randn(length(y),1).*sqrt(cov(y)); end;  
        Xl=[y(1:end,:),s(1:end,:)]; Xl=cleanNaN(Xl); 
        y_level=Xl(:,1); s_level=Xl(:,2); 
        s_diff=diff(s_level,1); y_diff=diff(y_level,1);  
        y_level=y_level(2:end,:); s_level=s_level(2:end,:);
        
        %Lag length
        if bic==1; BIClag=ICvar(y,6,1,'BIC'); table_bic=[table_bic;BIClag]; p=BIClag; 
        end;
        Xi_b=var_phi1b(y,p,const,b); 
        eps=var_res(y,p,const); 
        DeltaXf=(a*(inv(Xi_b))*eps')';
        VarRatio=[VarRatio;cov(DeltaXf)/cov(s(p+1:end))];
        VarRatiomiss=cov(DeltaXf)/cov(s(p+1:end)).*nan;
        
        %Instability tests
        %(a) on the AR coefficients:
        ylagged=[]; for j=1:p;
            ylagged=[ylagged,y(p+1-j:end-j,:)];
        end;
        result=testshac(y(p+1:end,:),ylagged,[1:1:p+1],0,Rwindow); 
        table_instability=[table_instability;result];
        table_instability_date=[table_instability_date;BreakDate(y(p+1:end,:),ylagged,[1:1:p+1],0,1,time)'];
       
        %(b) on the parameter relating exchange rates and fundamentals
        result1=testshac(s(p+1+1:end),DeltaXf(1:end-1),[1,2],0,Rwindow); 
        table_instability1=[table_instability1;result1];
        table_instability1_date=[table_instability1_date;BreakDate(s(p+1+1:end),DeltaXf(1:end-1),[1,2],0,1,time)];
        
        %(c) GC test: fundamentals GC exchange rates?
        result2=testshac(s(2:end),[y(1:end-1),s(1:end-1)],[1,2],3,Rwindow);    
        if tableb==1; result2=testshac(s(2:end),[y(1:end-1),s(1:end-1)],2,[1,3],Rwindow); end;
        if lagdep==0; 
            if rwwd==0;
            result2F=testshac(s(2:end),[y(1:end-1)],[1,2],0,Rwindow);  
            if tableb==1; result2F=testshac(s(2:end),[y(1:end-1)],[2],1,Rwindow);    end;
            elseif rwwd==1;
            result2F=testshacRWWD(s(2:end),[y(1:end-1)],[1,2],0,Rwindow); 
            if tableb==1; result2F=testshacRWWD(s(2:end),[y(1:end-1)],[1,2],0,Rwindow);    end;
            end;
        elseif lagdep==1; 
        result2F=testshacAR(s(2:end),[y(1:end-1),s(1:end-1)],[2],[1,3],Rwindow);   
        if tableb==1; result2F=testshacAR(s(2:end),[y(1:end-1),s(1:end-1)],[2],[1,3],Rwindow);    end; 
        end;
        table_instability2=[table_instability2;result2];
        table_instability2F=[table_instability2F;result2F];
        if tableb==0; table_instability2_date=[table_instability2_date;BreakDate(s(2:end),y(1:end-1),[1,2],0,1,time)];
        elseif tableb==1; table_instability2_date=[table_instability2_date;BreakDate(s(2:end),y(1:end-1),[2],1,1,time)]; end;
        missdate=BreakDate(s(2:end),y(1:end-1),[1,2],0,1,time).*nan;  
        

        %(d) GC test: exchange rates GC fundamentals
        result3=testshac(y(2:end),[s(1:end-1),y(1:end-1)],[1,2],3,Rwindow);   
        if tableb==1; result3=testshac(y(2:end),[s(1:end-1),y(1:end-1)],[2],[1,3],Rwindow); end;
        if lagdep==0; 
            if rwwd==0;
            result3F=testshac(y(2:end),[s(1:end-1)],[1,2],0,Rwindow);
            if tableb==1; result3F=testshac(y(2:end),[s(1:end-1)],[2],1,Rwindow); end;
                if tableb==0; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),s(1:end-1),[1,2],0,1,time)];
                elseif tableb==1; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),s(1:end-1),[2],1,1,time)]; end; 
            
            elseif rwwd==1;
            result3F=testshacRWWD(y(2:end),[s(1:end-1)],[1,2],0,Rwindow); 
            if tableb==1; result3F=testshacRWWD(y(2:end),[s(1:end-1)],[1,2],0,Rwindow); end;
                if tableb==0; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),s(1:end-1),[1,2],0,1,time)];
                elseif tableb==1; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),s(1:end-1),[2],1,1,time)]; end; 
            end;
        elseif lagdep==1; 
        result3F=testshacAR(y(2:end),[s(1:end-1),y(1:end-1)],[2],[1,3],Rwindow);  
        if tableb==1; result3F=testshacAR(y(2:end),[s(1:end-1),y(1:end-1)],[2],[1,3],Rwindow); end;
                if tableb==0; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),[s(1:end-1),y(1:end-1)],2,[1,3],1,time)];
                elseif tableb==1; table_instability3_date=[table_instability3_date;BreakDate(y(2:end),[s(1:end-1),y(1:end-1)],[2],[1,3],1,time)]; end; 
        end;
        table_instability3=[table_instability3;result3];
        table_instability3F=[table_instability3F;result3F];
        
        
        
     else; 
        table_correl=[table_correl;cor.*nan];
        table_instability=[table_instability;result.*nan];
        table_instability_date=[table_instability_date;missdate'];
        table_instability1=[table_instability1;result1.*nan];
        table_instability1_date=[table_instability1_date;missdate];
        table_instability2=[table_instability2;result2.*nan];
        table_instability2F=[table_instability2F;result2.*nan];
        table_instability2_date=[table_instability2_date;missdate];
        table_instability3=[table_instability3;result3.*nan];
        table_instability3F=[table_instability3F;result3.*nan];
        table_instability3_date=[table_instability3_date;missdate];
        VarRatio=[VarRatio;VarRatiomiss];
     end;  

        
    end; 

%Save p-values only
jpval=[2:2:2*NC];
tn=2; %2=picks andrews in instab tests, 3 picks Exp-W
TableFundTVP=[TableFundTVP;table_instability(jpval,tn)']; 
TableFundTVP_date=[TableFundTVP_date;table_instability_date'];
TableFundOpt=[TableFundOpt;table_instability(jpval,5)']; 
TableGC     =[TableGC;     table_instability3(jpval,1)']; 
TableGCTVP  =[TableGCTVP;  table_instability3(jpval,tn)']; 
TableGCTVP_date  =[TableGCTVP_date;  table_instability3_date']; 
TableGCOpt  =[TableGCOpt;  table_instability3(jpval,5)']; 
TableMSE    =[TableMSE;    table_instability3F([1:2:end-1],11)']; 
TableCMcCRol=[TableCMcCRol;table_instability3F(jpval,end)']; 
TableCMcCRec=[TableCMcCRec;table_instability3F(jpval,end-1)']; 
TableGC1    =[TableGC1;    table_instability2(jpval,1)']; 
TableGCTVP1 =[TableGCTVP1; table_instability2(jpval,tn)']; 
TableGCTVP1_date =[TableGCTVP1_date; table_instability2_date']; 
TableGCOpt1 =[TableGCOpt1; table_instability2(jpval,5)']; 
TableMSE1   =[TableMSE1;   table_instability2F([1:2:end-1],11)']; 
TableCMcCRol1=[TableCMcCRol1;  table_instability2F(jpval,end)']; 
TableCMcCRec1=[TableCMcCRec1;  table_instability2F(jpval,end-1)']; 
TableGCNPV =[TableGCNPV;   [table_instability1(jpval,[1,2,5,end])';table_instability1([1:2:end-1],[end])']]; 
Table_VarRatio=[Table_VarRatio; [VarRatio']];
Table_VarRatioMC=[Table_VarRatioMC; [VarRatio';table_quantiles']];
Table_VarRatioK=[Table_VarRatioK; [VarRatio'; table_quantiles_Kilian']];

end;  

delete Table6.out; diary Table6.out;
disp('EXCHANGE RATES GC FUNDAMENTALS');
disp('FUNDAMENTALS GC EXCHANGE RATES');
disp('DISR,DILR,DINF,DlrY,IMP,lnCP');

disp('Table: Bivariate Granger Causality Tests');
disp('GC'); disp(TableGC);  disp(TableGC1); 

disp('Table: Andrew''s QLR test for instabilities');
disp('TVP'); disp(TableGCTVP); disp(TableGCTVP1); 
disp('TVP DATES'); disp(TableGCTVP_date); disp(TableGCTVP1_date);

disp('Table: Granger causality Tests robust to Instabilities, Rossi (2005)');
disp('Opt'); disp(TableGCOpt); disp(TableGCOpt1);

disp('Table: Tests for out-of-sample forecasting ability');
disp('MSE'); disp(TableMSE); disp(TableMSE1);
disp('ClarkMcCracken ROLL'); disp(TableCMcCRol); disp(TableCMcCRol1);


diary off; 
