function result=nyblomstar(y,x,z,w,heter,b0);
%Calculates optimal Nyblom test 
%y is (T*1) dependent variable
%x is (T*p) independent variable whose param are time-varying
%z is (T*q) independent variable whose param are not time-varying
%w is (T*m) vector of instruments 
%if no subsets then set z=0; if OLS then set w equal to x

if z==0;
    e=y-x*b0; [T,k]=size(x); 
    if heter==1; Sigma=w'*(diag(e.^2))*w/T; end;
    if heter==0; s2=(sum(e.^2)/T); Sigma=s2*w'*w/T; end; 
    we=w.*0; for i=1:T; we(i,:)=w(i,:)*e(i,:); end;
    es=cumsum(we)/sqrt(T);
    sum1=0; for i=1:T; sum1=sum1+es(i,:)*(inv(Sigma))*es(i,:)'/T; end;
    result=sum1;
else;
    e=gmmres(y-x*b0,z,w,heter); [T,k]=size(z);
    if heter==1; Sigma=w'*(diag(e.^2))*w/T; 
    elseif heter==0; e2=cumsum(e.^2); s2=(e2(T,1))/(T-k); Sigma=s2*w'*w/T; end; 
    we=w.*0; for i=1:T; we(i,:)=w(i,:)*e(i,:); end;
    Mbetabar=(inv(sqrtm(Sigma)))*(-w'*x./T); Mdeltabar=(inv(sqrtm(Sigma)))*(-w'*z./T);
    Pbardelta=Mdeltabar*(inv(Mdeltabar'*Mdeltabar))*Mdeltabar';
    omegaN=Mbetabar'*(eye(length(Pbardelta))-Pbardelta)*Mbetabar;
    GradQ=x.*0; for i=1:T; GradQ(i,:)=w(i,:)*e(i,:)*(inv(sqrtm(Sigma)))*Mbetabar; end; %notice that GradQ is transposed rel. to def. in paper
    GradQpiT=cumsum(GradQ)./sqrt(T);
    sum1=0; for i=1:T; sum1=sum1+GradQpiT(i,:)*(inv(omegaN))*GradQpiT(i,:)'/T; end;
    result=sum1;    
end;