function result = plotforectestshac(e1,p1,listrestr,listunr,tds,R);

load pvapiopt.txt; load pvap0opt.txt; load pvqlropt.txt; load pvnybopt.txt;
load pvapisb.txt; load pvap0sb.txt; load pvqlrsb.txt; load pvnybsb.txt;

heter=1; %heter=1 if robust to cond heteroskedasticity; heter=0 if cond homoskedasticity is imposed
hac  =1; %hac=1 if robust to serial correlation (Newey-West with bandwidth=T^(1/3))

[T,kk]=size(p1); ba0=0;
p1plusc=[ones(T,1),p1]; p1restr=p1plusc(:,listrestr); 
if listunr==0; p1unr=0; else p1unr=p1plusc(:,listunr); end;
[T,kk]=size(p1restr); 

   % LRtest
   restr=length(listrestr); iden=eye(size(p1)+1); RR=iden(listrestr,:); 
   bhat=gmmbeta(e1,[ones(T,1),p1],[ones(T,1),p1],heter);
   varb=gmmvarhac(e1,[ones(T,1),p1],[ones(T,1),p1],heter,hac);
   LLR=T*( (RR*bhat)'* (inv(RR*(varb)*RR')) *  (RR*bhat)  );
   pvLLR=cdfchic(LLR,restr);
   
   % TVP and Optimal tests
   t2v=round(T*0.15):1:round(T*0.85); 
   Andrews=zeros(length(t2v),1); AP=0;Nyb=0; Nyb0=0; LLR7v=zeros(length(t2v),1); AP0=0; AP00=0;
   for t2=t2v;
   chow=chowgmmhac(e1,p1restr,p1unr,p1plusc,t2,heter,hac);
   Andrews(t2-round(T*0.15)+1,1)=chow;
   AP=AP+(exp(0.5*chow));
   Nyb=Nyb+chow*(t2/T)*(1-t2/T);
   LLR7=chowgmmstarhac(e1,p1restr,p1unr,p1plusc,t2,heter,hac);
   LLR7v(t2-round(T*0.15)+1,1)=LLR7;
   AP0=AP0+(exp(0.5*LLR7)); %use q*F asy equiv to LR and Wald
   AP00=AP00+LLR7;Nyb0=Nyb0+LLR7*(t2/T)*(1-t2/T);
   end;
   Jinv=1/length(t2v);
   SupLR=max(Andrews); ExpW=log( (inv(.85-.15))*AP/T);
   SupLRopt=max(LLR7v); ExpWopt=log( (inv(.85-.15))*AP0/T);
   MeanWopt=( (inv(.85-.15))*AP00/T );
   Nyblom=( (inv(.85-.15))*Nyb/T );
   Nyblomopt=nyblomstar(e1,p1restr,p1unr,p1plusc,heter,zeros(kk,1));
   
% P-values
pvNyblom=pvcalc(Nyblom,pvnybsb,restr);
pvSupLR=pvcalc(SupLR,pvqlrsb,restr);
pvNyblomopt=pvcalc(Nyblomopt,pvnybopt,restr);
pvExpW=pvcalc(ExpW,pvapisb,restr);
pvSupLRopt=pvcalc(SupLRopt,pvqlropt,restr);
pvExpWopt=pvcalc(ExpWopt,pvapiopt,restr);
pvMeanWopt=pvcalc(MeanWopt,pvap0opt,restr);

%Oos tests for predictive ability
if nargin==5; R=round((0.5)*T); end;  Pred=T-R; 
yo1=zeros(T,1);rw1=zeros(T,1);true1=zeros(T,1);b0=0;yosplit1=zeros(T,1);yoroll1=zeros(T,1);
brollvec=[];
for j=1:Pred;
   boos=olsbeta(e1(1:R+j-1,1),[ones(R+j-1,1),p1(1:R+j-1,:)]);
   bsplit=olsbeta(e1(1:R,1),[ones(R,1),p1(1:R,:)]);
   yo1(R+j,1)=[1,p1(R+j,:)]*boos';
   yosplit1(R+j,1)=[1,p1(R+j,:)]*bsplit';
   broll=olsbeta(e1(j:R+j-1,1),[ones(R,1),p1(j:R+j-1,:)]); 
        brollvec=[brollvec;broll]; save brollvec brollvec -ascii; 
   yoroll1(R+j,1)=[1,p1(R+j,:)]*broll';
   rw1(R+j,1)=0;
   true1(R+j,1)=e1(R+j);
end;
%Sequential tests
yo=yo1(R+1:T,1);rw=rw1(R+1:T,1);true=true1(R+1:T,1);yosplit=yosplit1(R+1:T,1);
u1=(true-yo).^2; u2=(true-rw).^2; f=u1-u2;
varf=cov(f)/(Pred); 
DMrecurs=media(f)/sqrt(varf);
pvDMrecurs=cdfchic(DMrecurs^2,1);
ENCNEWrecurs=Pred*(media(u2.^2-u1.*u2))/(media((u1-media(u1)).^2)); 
pvENCNEWrecurs=1; if ENCNEWrecurs>ooscv(restr,0.1,2,1); pvENCNEWrecurs=0.10; end; if ENCNEWrecurs>ooscv(restr,0.05,2,1); pvENCNEWrecurs=0.05; end; if ENCNEWrecurs>ooscv(restr,0.01,2,1); pvENCNEWrecurs=0.01; end;

%Rolling tests
yoroll=yoroll1(R+1:T,1); u1roll=(true-yoroll).^2; u2roll=(true-rw).^2; froll=u1roll-u2roll; 
figure;
plot(tds(R+1:T,:),yoroll,'+--'), hold on; plot(tds(R+1:T,:),true,'LineWidth',2); plot(tds(R+1:T,:),rw);
legend('Model''s forecast','Actual realization'); 
xlabel('Time'); ylabel('Global commodity price change'); axis tight; hold off; 
varfroll=cov(froll)/(Pred); 
DMroll=media(froll)/sqrt(varfroll);
pvDMroll=cdfchic(DMroll^2,1);
ENCNEWroll=Pred*(media(u2.^2-u1roll.*u2))/(media((u1roll-media(u1roll)).^2)); 
pvENCNEWroll=1; if ENCNEWroll>ooscv(restr,0.1,2,2); pvENCNEWroll=0.10; end; if ENCNEWroll>ooscv(restr,0.05,2,2); pvENCNEWroll=0.05; end; if ENCNEWroll>ooscv(restr,0.01,2,2); pvENCNEWroll=0.01; end;

%Split tests
u1split=(true-yosplit).^2; fsplit=u1split-u2;
varfsplit=cov(fsplit)/(Pred); 
DMsplit=media(fsplit)/sqrt(varfsplit);
pvDMsplit=cdfchic(DMsplit^2,1);
ENCNEWsplit=Pred*(media(u2.^2-u1split.*u2))/(media((u1split-media(u1split)).^2)); 
pvENCNEWsplit=1; if ENCNEWsplit>ooscv(restr,0.1,2,3); pvENCNEWsplit=0.10; end; if ENCNEWsplit>ooscv(restr,0.05,2,3); pvENCNEWsplit=0.05; end; if ENCNEWsplit>ooscv(restr,0.01,2,3); pvENCNEWsplit=0.01; end;

result=[LLR,SupLR,ExpW,Nyblom,ExpWopt,MeanWopt,Nyblomopt,SupLRopt,DMsplit,DMrecurs,DMroll,ENCNEWsplit,ENCNEWrecurs,ENCNEWroll;pvLLR,pvSupLR,pvExpW,pvNyblom,pvExpWopt,pvMeanWopt,pvNyblomopt,pvSupLRopt,pvDMsplit,pvDMrecurs,pvDMroll,pvENCNEWsplit,pvENCNEWrecurs,pvENCNEWroll];

